#ifndef _SCENEH_
#define _SCENEH_

#include "sprite.h"

typedef struct scene_struct scene_t;

typedef void (*scene_func_t)(scene_t*, int);

struct scene_struct{
	scene_func_t init_func; // update function
	scene_func_t update_func; // update function
	sprite_t** sprites; // pointer storing all the sprites
	int nsprite; // how many sprites are we rendering
    char reset; // indicates whether to reset the scene or not
} ;

void scene_init(scene_t* s, int dt);

void scene_update(scene_t* s, int dt);

#endif