#include "game_manager.h"

// ========================= text sprite ===========================
char disp_str[10];
unsigned char countdown;
extern volatile int time_tick_60_hz;
char countdown_text_enabled = 0;
void countdown_text_update(sprite_t* s, int dt){
    if (countdown_text_enabled){
        video_string(s->pos.x, s->pos.y, disp_str);
    }
}

void countdown_text_init(sprite_t* s, int dt){
    vector2d pos = {(right-left)/2,(bottom-top)/2 - 3};
    s->pos = pos;
    s->update_func = countdown_text_update;
    countdown_text_enabled = 0;
}

sprite_t countdown_text = {0,0,0,0,0,0,countdown_text_init,0,0};

// ========================= BG sprite ===========================
int bg_complete = 0; // complete at 100
int bg_upd_time = 0;
int banner_load_done = 0;
void countdown_bg_update(sprite_t* s, int dt){
    if ((time_tick_60_hz-bg_upd_time) >= 1){
        if (bg_complete >= 101) {
            if (banner_load_done == 0){
                countdown_text_enabled = 1;
                video_fillRect(left, s->pos.y, right, s->height, DRAW_BLACK);
                video_line(left, s->pos.y, right, s->pos.y, DRAW_WHITE);
                video_line(left, s->pos.y+s->height, right, s->pos.y+s->height, DRAW_WHITE);
                DmaChnEnable(DMAhit);
                banner_load_done = 1;
            }
            return;
        } else {
            video_fillRect(left, s->pos.y, (right-left)*bg_complete/100, s->height, DRAW_BLACK);
            video_line(left, s->pos.y, left+(right-left)*bg_complete/100, s->pos.y, DRAW_WHITE);
            video_line(left, s->pos.y+s->height, left+(right-left)*bg_complete/100, s->pos.y+s->height, DRAW_WHITE);
            bg_complete += 10;
        }
        bg_upd_time == time_tick_60_hz;
    }
}

void countdown_bg_init(sprite_t* s, int dt){
    vector2d pos = {0, (bottom+top)/2-15};
    s->pos = pos;
    s->height = 30;
    s->update_func = countdown_bg_update;
    bg_complete = 0;
    bg_upd_time = time_tick_60_hz;
    banner_load_done = 0;
}

sprite_t countdown_bg = {0,0,0,0,0,0,countdown_bg_init,0,0};

// ====================== countdown scene =============================
sprite_t* countdown_scene_sprites[2];

int counter_tick;
void scene_countdown_update(scene_t* s, int dt){
    int i;
    // update its children sprites first
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->update_func(s->sprites[i], 0);
    }
    
    if (bg_complete < 101){
        counter_tick = time_tick_60_hz;
    }
    
    if (time_tick_60_hz-counter_tick >= 60 && bg_complete >= 101){
        countdown--;
        sprintf(disp_str, "%d", countdown);
        counter_tick = time_tick_60_hz;
        if (countdown != 0) DmaChnEnable(DMAhit);
    }
    
    if (countdown == 0){
        DmaChnEnable(DMAbgm);
        game_manager_load_scene(1);
    }
    
}

void scene_countdown_init(scene_t* s, int dt){
    int i;
    
    //video_clr(); // clear screen
    
    s->nsprite = 2;
    s->sprites = countdown_scene_sprites;
    s->sprites[1] = &countdown_text;
    s->sprites[0] = &countdown_bg;
    
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->init_func(s->sprites[i], 0);
    }
    
    s->update_func = scene_countdown_update;
    
    // init the scene here
    countdown = 3;
    sprintf(disp_str, "%d", countdown);
    counter_tick = time_tick_60_hz;
    
    DmaChnDisable(DMAbgm);
    
}

scene_t scene_countdown = {scene_countdown_init, NULL, NULL, 0};