#include "game_manager.h"

char selected_p = 0, selected_old_p = 0;
// ============================ button sprite ===========================

char resume_button_str[10];
void resume_button_update(sprite_t* s, int dt){
    if (selected_old_p != selected_p){
    if (selected_p == 0){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
        video_removestring(s->pos.x + (s->width)/2 - 16, s->pos.y+(s->height)/2-3, resume_button_str);
    } else if (selected_old_p == 0 && selected_p != selected_old_p){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_BLACK);
        video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
        video_string(s->pos.x + (s->width)/2 - 16, s->pos.y+(s->height)/2-3, resume_button_str);
    }
    }
}

void resume_button_init(sprite_t*s, int dt){
    s->width = 60;
    s->height = 15;
    vector2d pos = {(right+left)/2-30,(top+bottom)/2-25};
    s->pos = pos;
    s->current_frame = 0;
    s->data = NULL;
    s->frames = 0;
    s->update_func = resume_button_update;
    sprintf(resume_button_str, "Resume");
    video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
    video_removestring(s->pos.x + (s->width)/2 - 16, s->pos.y+(s->height)/2-3, resume_button_str);
}

sprite_t resume_button = {0,0,0,0,0,0,resume_button_init,0,0};

char restart_button_str[10];
void restart_button_update(sprite_t* s, int dt){
    if (selected_old_p != selected_p){
    if (selected_p == 1) {
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
        video_removestring(s->pos.x + (s->width)/2 - 18, s->pos.y+(s->height)/2-3, restart_button_str);
    } else if (selected_old_p == 1){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_BLACK);
        video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
        video_string(s->pos.x + (s->width)/2 - 18, s->pos.y+(s->height)/2-3, restart_button_str);
    }
    }
}

void restart_button_init(sprite_t*s, int dt){
    s->width = 60;
    s->height = 15;
    vector2d pos = {(right+left)/2-30,(top+bottom)/2-5};
    s->pos = pos;
    s->current_frame = 0;
    s->data = NULL;
    s->frames = 0;
    s->update_func = restart_button_update;
    sprintf(restart_button_str, "Restart");
    video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
    video_string(s->pos.x + (s->width)/2 - 18, s->pos.y+(s->height)/2-3, restart_button_str);
}

sprite_t restart_button = {0,0,0,0,0,0,restart_button_init,0,0};

char menu_button_str[10];
void menu_button_update(sprite_t* s, int dt){
    if (selected_old_p != selected_p){
    if (selected_p == 2){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_WHITE);
        video_removestring(s->pos.x + (s->width)/2 - 26, s->pos.y+(s->height)/2-3, menu_button_str);
    } else if (selected_old_p == 2){
        video_fillRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, DRAW_BLACK);
        video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
        video_string(s->pos.x + (s->width)/2 - 26, s->pos.y+(s->height)/2-3, menu_button_str);
    }
    }
}

void menu_button_init(sprite_t*s, int dt){
    s->width = 60;
    s->height = 15;
    vector2d pos = {(right+left)/2-30,(top+bottom)/2+15};
    s->pos = pos;
    s->current_frame = 0;
    s->data = NULL;
    s->frames = 0;
    s->update_func = menu_button_update;
    sprintf(menu_button_str, "Main Menu");
    video_drawRoundRect((s->pos.x), (s->pos.y), s->width, s->height, 4, OPT_OVERLAY);
    video_string(s->pos.x + (s->width)/2 - 26, s->pos.y+(s->height)/2-3, menu_button_str);
}

sprite_t menu_button = {0,0,0,0,0,0,menu_button_init,0,0};

// ============================= menu scene =============================
sprite_t* pause_scene_sprites[3];

char key_string[5];
extern char key_old;
void scene_pause_update(scene_t* s, int dt){
    int i;
    
    if (getbuttondown(KEY_DOWN)){
        if (!(key_old & 1)) {
            DmaChnEnable(DMAhit);
            selected_p ++;
            if (selected_p > 2) selected_p = 0;
        }
        key_old |= 1;
    } else {
        key_old &= ~(1<<0);
    }
    
    if (getbuttondown(KEY_UP)){
        if (!(key_old & (1<<1))) {
            DmaChnEnable(DMAhit);
            selected_p --;
            if (selected_p < 0) selected_p = 2;
        }
        key_old |= (1 << 1);
    } else {
        key_old &= ~(1 << 1);
    }
    
    // update its children sprites first
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->update_func(s->sprites[i], 0);
    }
    
    selected_old_p = selected_p;
    
    sprintf(key_string, "%d", selected_p);
    video_string(left+10, bottom-10, key_string);
    
    if (getbuttondown(KEY_A)){
        if (!(key_old & (1<<2))) {
            if (selected_p == 0){
                DmaChnEnable(DMAhit);
                game_manager_load_scene(2);
            } else if (selected_p == 1){
                DmaChnEnable(DMAhit);
                game_manager_get_scene(1)->reset = 1;
                game_manager_load_scene(2);
            } else {
                DmaChnEnable(DMAhit);
                game_manager_load_scene(0);
            }
        }
        key_old |= (1 << 2);
    } else {
        key_old &= ~(1 << 2);
    }
}

char title_str[10];

void scene_pause_init(scene_t* s, int dt){
    int i;
    
    //video_clr(); // clear screen
    
    video_fillRect((right+left)/2-52, (bottom+top)/2-51, 104, 94, DRAW_BLACK);
    
    s->nsprite = 3;
    
    s->sprites = pause_scene_sprites;
    s->sprites[0] = &resume_button;
    s->sprites[1] = &restart_button;
    s->sprites[2] = &menu_button;
    
    s->update_func = scene_pause_update;
    
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->init_func(s->sprites[i], 0);
    }
    
    selected_p = 0;
    selected_old_p = 0;
    
    // init the scene here
    // Draw the screen boundaries
    video_drawRect((right+left)/2-50, (bottom+top)/2-49, 100, 90, DRAW_WHITE);
    
    sprintf(title_str, "Rope Jumper");
    video_string((left+right)/2-32, top+58, title_str);
    
    // audio config
    config_bgm(0);
    config_hit(0);
}

scene_t scene_pause = {scene_pause_init, NULL, NULL, 0};